
/*
 * DrawingPanel.java
 *
 * Created on 4. Juli 2007, 22:59
 *
 * Visualize as an example what linear interploation is.
 * www.sunshine2k.de
 */

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import javax.swing.JPanel;

/**
 *
 * @author Sunshine
 */
public class DrawingPanel extends JPanel {
    
    private MovablePoint Point1, Point2;
    public float t = 0.5f;
    private Color backColor = new Color(0, 153, 255);
    private int sizex = 500;
    private int sizey = 250;
    
    /** Creates a new instance of DrawingPanel */
    public DrawingPanel() {
       
        // set layout, size, color
        this.setLayout(null);
        this.setBounds(0, 0, sizex, sizey);
        this.setBackground(backColor);
       
        // Set both points to starting position
        Point1 = new MovablePoint(this, 20, 40);
        Point2 = new MovablePoint(this, 300, 130);
    }
    
    
    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D)g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2.drawLine(Point1.getX() + MovablePoint.SIZE2, Point1.getY() + MovablePoint.SIZE2, 
                    Point2.getX() + MovablePoint.SIZE2, Point2.getY() + MovablePoint.SIZE2);
        
        int tx = (int)(Point1.getX() * (1-t) + Point2.getX() * t);
        int ty = (int)(Point1.getY() * (1-t) + Point2.getY() * t);
        g2.setColor(Color.RED);
        g2.fillRect(tx, ty, MovablePoint.SIZE, MovablePoint.SIZE);
        
        // just to make it look better cause the both points are always in the foreground
        // so if the red rectangle is near them, it disappears :-(
        if (t == 0)
            Point1.setVisible(false);
        else
            Point1.setVisible(true);
        
        if (t == 1.0f)
            Point2.setVisible(false);
        else
            Point2.setVisible(true);
        
        // draw some info
        Font f = new Font("Arial", Font.PLAIN, 3);
        g2.setColor(Color.YELLOW);
        g2.drawString("P1 (" + Point1.getX() + "," + Point1.getY() + ") ; " +
                      "P2 (" + Point2.getX() + "," + Point2.getY() + ") ;  " + 
                      "-  Red Point: (" + tx + "," + ty + ")", 0, sizey - 5);
    }
   
    
}
