
/*
 * LinearInterpolationApplet.java
 *
 * Created on 4. Juli 2007, 21:56
 *
 * Size of applet is 500, 320
 */

/**
 *
 * @author  Sunshine
 */

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


public class LinearInterpolationApplet extends javax.swing.JApplet {
    
    private DrawingPanel drawPanel;
    
    /** Initializes the applet LinearInterpolationApplet */
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        setSize(500, 320);
        
        drawPanel = new DrawingPanel();
        getContentPane().add(drawPanel);
        ParameterField.setText("0.5");
        
        this.jPanel1.setBounds(0, 250, 500, 80);
        // react on slider
        this.ParameterSlider.addChangeListener(new ChangeListener()
        {
            public void stateChanged(ChangeEvent event)
            {
                float slidervalue = (float)ParameterSlider.getValue() / 1000;
                ParameterField.setText(Float.toString(slidervalue));
                drawPanel.t = slidervalue;
                drawPanel.repaint();
            }
        });

        // react on textfield actions
        this.ParameterField.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent event)
            {
                float slidervalue;
                try {
                    slidervalue = Float.parseFloat(ParameterField.getText());
                } catch (NumberFormatException ex) { return; }
                if (slidervalue < 0 || slidervalue > 1) return;
                drawPanel.t = slidervalue;
                drawPanel.repaint();
                ParameterSlider.setValue((int)(slidervalue * 1000));
            }
        });
        
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        ParameterSlider = new javax.swing.JSlider();
        ParameterField = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        getContentPane().setLayout(null);

        jPanel1.setLayout(null);

        jPanel1.setBackground(new java.awt.Color(204, 204, 204));
        jPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        ParameterSlider.setBackground(new java.awt.Color(204, 204, 204));
        ParameterSlider.setMaximum(1000);
        ParameterSlider.setValue(500);
        ParameterSlider.setPreferredSize(new java.awt.Dimension(300, 24));
        jPanel1.add(ParameterSlider);
        ParameterSlider.setBounds(100, 10, 300, 24);

        jPanel1.add(ParameterField);
        ParameterField.setBounds(220, 40, 60, 20);

        jLabel1.setText("t =");
        jPanel1.add(jLabel1);
        jLabel1.setBounds(190, 40, 15, 14);

        jLabel2.setText("0 <= t <= 1");
        jPanel1.add(jLabel2);
        jLabel2.setBounds(290, 40, 60, 14);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(0, 210, 400, 70);

    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField ParameterField;
    private javax.swing.JSlider ParameterSlider;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
