/*
 * MovablePoint.java
 *
 * Created on 4. Juli 2007, 21:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/**
 *
 * @author Sunshine
 */
public class MovablePoint extends javax.swing.JPanel {
    
    public static final int SIZE = 8;
    public static final int SIZE2 = SIZE / 2;
    private static DrawingPanel parent;
    
    private int oldX = 0, oldY = 0;
    
    
    public MovablePoint(DrawingPanel parent, int x, int y)
    {
        this.parent = parent;
        this.setLocation(x,y);
        this.setSize(SIZE, SIZE);
        this.setBackground(Color.BLACK);
        parent.add(this);
        repaint();
       
        setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
        
        this.addMouseMotionListener(new MouseAdapter() 
        {
            public void mouseMoved(MouseEvent event)
            {
                
               oldX = event.getX();
               oldY = event.getY();
            }
            
            public void mouseDragged(MouseEvent event)
            {
                // prevent draggin outside the applet
                if (getLocation().x + event.getX() > getParentBounds().width ||
                    getLocation().x + event.getX() < 0 ||
                    getLocation().y + event.getY() > getParentBounds().height ||
                    getLocation().y + event.getY() < 0)
                {
                    return;
                }
                    
                int xx = getLocation().x;
                int yy = getLocation().y;
                setLocation(xx +  event.getX() - oldX, yy + event.getY() - oldY);
                repaintParent();
            }
        });
    }
    
    public void repaintParent()
    {
        parent.repaint();
    }
    
    public Rectangle getParentBounds()
    {
        return parent.getBounds();
    }
    
    public int getX() { return getLocation().x; }
    public int getY() { return getLocation().y; }
    
}
